'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var unaryOperators = {
    '-': true,
    '+': true,
    '!': true,
    '~': true,
    'typeof': true,
    'void': true,
    'delete': true
};

var UnaryExpression = function (_Expression) {
    _inherits(UnaryExpression, _Expression);

    // TODO: Should respect operator precedence: putting "-a" after "b" without parens should raise an error.

    function UnaryExpression(childNodes) {
        _classCallCheck(this, UnaryExpression);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(UnaryExpression).call(this, 'UnaryExpression', childNodes));

        _this.prefix = true;
        return _this;
    }

    _createClass(UnaryExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            if (children.currentElement.type === 'Punctuator' || children.currentElement.type === 'Keyword') {
                children.assertToken(children.currentElement.type, unaryOperators);
            } else {
                children.assertToken('Punctuator');
            }

            var operator = children.passToken().value;
            children.skipNonCode();

            var argument = children.passExpression();

            children.assertEnd();

            this.argument = argument;
            this.operator = operator;
        }
    }]);

    return UnaryExpression;
}(_Expression3.default);

exports.default = UnaryExpression;
//# sourceMappingURL=UnaryExpression.js.map